package com.ibm.websphere.samples.cmpa;

//==============================================================================
//
// "This program may be used, executed, copied, modified and distributed without
// royalty for the purpose of developing, using, marketing, or distributing."
//
// Product 5724-H74,   5724-L01, 5655-N53, 5724-I82, 5655-R15 (C) COPYRIGHT International Business Machines Corp., 2004, 2006
// All Rights Reserved * Licensed Materials - Property of IBM
// US Government Users Restricted Rights - Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.
//
// @(#) 1.3 WBISRVR/ws/code/samp.cmpa/src/com/ibm/websphere/samples/cmpa/AccountBackend.java, WAS.samp.cmpa, WBI70.WBISRVR, of1033.11 4/13/06 22:09:56 [8/24/10 06:41:33]
//
//==============================================================================

import java.rmi.RemoteException;
import java.util.Vector;
import javax.ejb.DuplicateKeyException;
import javax.ejb.EJBObject;
import javax.ejb.ObjectNotFoundException;


/**
 * Remote interface for Enterprise Bean: AccountBackend
 */
public interface AccountBackend extends EJBObject {
	/**
	 * createAccount
	 */
	public void createAccount(String id, Float balance)
		throws DuplicateKeyException, RemoteException;
	/**
	 * retrieveAccount
	 */
	public AccountWrapper retrieveAccount(java.lang.String id)
		throws ObjectNotFoundException, RemoteException;
	/**
	 * updateAccount
	 */
	public boolean updateAccount(String id, Float balance)
		throws RemoteException;
	/**
	 * deleteAccount
	 */
	public boolean deleteAccount(String id)
		throws RemoteException;
	/**
	 * selectAccounts
	 */
	public Vector selectAccounts()
		throws RemoteException;
	/**
	 * retrieveMultipleAccounts
	 */
	public Vector retrieveMultipleAccounts(float threshold)
		throws RemoteException;
	/**
	 * creditAccount
	 */
	public float creditAccount(String id, float balance)
		throws ObjectNotFoundException, RemoteException;
	/**
	 * debitAccount
	 */
	public float debitAccount(String id, float balance)
		throws ObjectNotFoundException, InsufficientFundsException, RemoteException;
	/**
	 * resetAccounts
	 */
	public void resetAccounts()
		throws RemoteException;
}
