package com.ibm.websphere.samples.cmpa;

//==============================================================================
//
// "This program may be used, executed, copied, modified and distributed without
// royalty for the purpose of developing, using, marketing, or distributing."
//
// Product 5724-H74,   5724-L01, 5655-N53, 5724-I82, 5655-R15 (C) COPYRIGHT International Business Machines Corp., 2004, 2006
// All Rights Reserved * Licensed Materials - Property of IBM
// US Government Users Restricted Rights - Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.
//
// @(#) 1.3 WBISRVR/ws/code/samp.cmpa/src/com/ibm/websphere/samples/cmpa/AccountBackendLocal.java, WAS.samp.cmpa, WBI70.WBISRVR, of1033.11 4/13/06 22:10:02 [8/24/10 06:41:33]
//
//==============================================================================

import javax.ejb.DuplicateKeyException;
import javax.ejb.EJBLocalObject;
import javax.ejb.ObjectNotFoundException;
import java.util.Vector;


/**
 * Local interface for Enterprise Bean: AccountBackend
 */
public interface AccountBackendLocal extends EJBLocalObject {
	public void createAccount(String id, Float balance) throws DuplicateKeyException;
	
	public AccountWrapper retrieveAccount(String id) throws ObjectNotFoundException;
	
	public boolean updateAccount(String id, Float balance);
	
	public boolean deleteAccount(String id);
	
	public Vector selectAccounts();

	public Vector retrieveMultipleAccounts(float threshold);

	public float creditAccount(String id, float balance) throws ObjectNotFoundException;
	
	public float debitAccount(String id, float balance) throws ObjectNotFoundException, InsufficientFundsException;;
	
	public void resetAccounts();
}
