package com.ibm.websphere.samples.cmpa;

//==============================================================================
//
// "This program may be used, executed, copied, modified and distributed without
// royalty for the purpose of developing, using, marketing, or distributing."
//
// Product 5724-H74,   5724-L01, 5655-N53, 5724-I82, 5655-R15 (C) COPYRIGHT International Business Machines Corp., 2004, 2006
// All Rights Reserved * Licensed Materials - Property of IBM
// US Government Users Restricted Rights - Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.
//
// @(#) 1.4 WBISRVR/ws/code/samp.cmpa/src/com/ibm/websphere/samples/cmpa/AccountBean.java, WAS.samp.cmpa, WBI70.WBISRVR, of1033.11 4/13/06 22:10:07 [8/24/10 06:41:33]
//
//==============================================================================

import java.util.Collection;
import java.util.Iterator;
import javax.ejb.CreateException;
import javax.ejb.EntityBean;
import javax.ejb.EntityContext;
import javax.ejb.FinderException;
import javax.ejb.RemoveException;


/**
 * Bean implementation class for Enterprise Bean: Account
 */
public abstract class AccountBean implements EntityBean {
	private EntityContext myEntityCtx;
	/**
	 * setEntityContext
	 */
	public void setEntityContext(EntityContext ctx) {
		myEntityCtx = ctx;
	}
	/**
	 * getEntityContext
	 */
	public EntityContext getEntityContext() {
		return myEntityCtx;
	}
	/**
	 * unsetEntityContext
	 */
	public void unsetEntityContext() {
		myEntityCtx = null;
	}
	/**
	 * ejbCreate
	 */
	public String ejbCreate(String id) throws CreateException {
		setId(id);
		return null;
	}
	/**
	 * ejbPostCreate
	 */
	public void ejbPostCreate(String id) throws CreateException {
	}
	/**
	 * ejbCreate
	 */
	public String ejbCreate(String id, float balance) throws CreateException {
		setId(id);
		setBalance(balance);
		return null;
	}
	/**
	 * ejbPostCreate
	 */
	public void ejbPostCreate(String id, float balance) throws CreateException {
	}
	/**
	 * ejbActivate
	 */
	public void ejbActivate() {
	}
	/**
	 * ejbLoad
	 */
	public void ejbLoad() {
	}
	/**
	 * ejbPassivate
	 */
	public void ejbPassivate() {
	}
	/**
	 * ejbRemove
	 */
	public void ejbRemove() throws RemoveException {
	}
	/**
	 * ejbStore
	 */
	public void ejbStore() {
	}
	/**
	 * Get accessor for persistent attribute: id
	 */
	public abstract String getId();
	/**
	 * Set accessor for persistent attribute: id
	 */
	public abstract void setId(String newId);
	/**
	 * Get accessor for persistent attribute: balance
	 */
	public abstract float getBalance();
	/**
	 * Set accessor for persistent attribute: balance
	 */
	public abstract void setBalance(float newBalance);
	
	/**
	 * Data logic method: credit
	 */
	public abstract float credit(float amount);
	/**
	 * Data logic method: debit
	 */
	public abstract float debit(float amount) throws InsufficientFundsException;
	/**
	 * Data logic method: ejbHomeReset
	 */
	public abstract void ejbHomeReset();
	
	public abstract Collection ejbSelectAllBalances() throws FinderException;
	
	public float ejbHomeComputeTotalBalances() throws FinderException {
		float total = 0;

		Collection balances = ejbSelectAllBalances();
		Iterator iter = balances.iterator();
		while (iter.hasNext()) {
			Float balance = (Float) iter.next();
			total += balance.floatValue();
		}
		
		return total;
	}
}
