package com.ibm.websphere.samples.cmpa;

//==============================================================================
//
// "This program may be used, executed, copied, modified and distributed without
// royalty for the purpose of developing, using, marketing, or distributing."
//
// Product 5724-H74,   5724-L01, 5655-N53, 5724-I82, 5655-R15 (C) COPYRIGHT International Business Machines Corp., 2005, 2006
// All Rights Reserved * Licensed Materials - Property of IBM
// US Government Users Restricted Rights - Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.
//
// @(#) 1.5 WBISRVR/ws/code/samp.cmpa/src/com/ibm/websphere/samples/cmpa/AccountGallery.java, WAS.samp.cmpa, WBI70.WBISRVR, of1033.11 4/13/06 22:15:06 [8/24/10 06:41:38]
//
//==============================================================================

import com.ibm.websphere.samples.cmpa.Account;
import com.ibm.websphere.samples.cmpa.AccountHome;
import java.util.Collection;
import java.util.Iterator;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;

public class AccountGallery {
   public static String getResult(String backEndType, String operation, String key, String amountString) {
      String resultValue = null;
      if ((backEndType != null) && !backEndType.equals("")) try {
         float amount = 0.0f;
         if ((amountString != null) && !amountString.equals("")) amount = Float.parseFloat(amountString);
         InitialContext ctx = new InitialContext();

         Object obj = ctx.lookup("java:comp/env/ejb/Account"+backEndType);
         AccountHome home = (AccountHome) PortableRemoteObject.narrow(obj, AccountHome.class);
         Account bean = null;

         if (operation.equals("ejbCreate")) {
            bean = home.create(key, amount);
         }

         if (operation.equals("ejbFindByPrimaryKey")) {
            bean = home.findByPrimaryKey(key);
            resultValue = ""+bean.getBalance();
         }

         if (operation.equals("ejbStore")) {
            bean = home.findByPrimaryKey(key);
            bean.setBalance(amount);
         }

         if (operation.equals("ejbRemove")) {
            bean = home.findByPrimaryKey(key);
            bean.remove();
         }

         if (operation.equals("ejbFindByBalanceThreshold")) {
            resultValue = "";
            Collection beans = home.findByBalanceThreshold(amount);
            Iterator iter = beans.iterator();
            while (iter.hasNext()) {
               bean = (Account) iter.next();
               String id = bean.getId();
               float balance = bean.getBalance();

               resultValue += "<br>"+id+": "+balance;
            }
         }

         if (operation.equals("ejbSelectAllBalances")) {
            resultValue = ""+home.computeTotalBalances();
         }

         if (operation.equals("ejbHomeReset")) {
            home.reset();
         }

         if (operation.equals("debit")) {
            bean = home.findByPrimaryKey(key);
            resultValue = ""+bean.debit(amount);
         }

         if (operation.equals("credit")) {
            bean = home.findByPrimaryKey(key);
            resultValue = ""+bean.credit(amount);
         }
      } catch (Throwable t) {
         t.printStackTrace(); //goes to SystemErr.log (and trace.log, if enabled)
         resultValue = t.toString();
      } else {
         resultValue = "";
      }
      return resultValue;
   }
}
