package com.ibm.websphere.samples.cmpa;

//==============================================================================
//
// "This program may be used, executed, copied, modified and distributed without
// royalty for the purpose of developing, using, marketing, or distributing."
//
// Product 5724-H74,   5724-L01, 5655-N53, 5724-I82, 5655-R15 (C) COPYRIGHT International Business Machines Corp., 2004, 2006
// All Rights Reserved * Licensed Materials - Property of IBM
// US Government Users Restricted Rights - Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.
//
// @(#) 1.4 WBISRVR/ws/code/samp.cmpa/src/com/ibm/websphere/samples/cmpa/AccountLocalHome.java, WAS.samp.cmpa, WBI70.WBISRVR, of1033.11 4/13/06 22:10:23 [8/24/10 06:41:34]
//
//==============================================================================

import java.util.Collection;
import javax.ejb.CreateException;
import javax.ejb.EJBLocalHome;
import javax.ejb.FinderException;


/**
 * Local Home interface for Enterprise Bean: Account
 */
public interface AccountLocalHome extends EJBLocalHome {
	/**
	 * Creates an instance from a key for Entity Bean: Account
	 */
	public AccountLocal create(String id)
		throws CreateException;

	/**
	 * Creates an instance from a key and balance for Entity Bean: Account
	 */
	public AccountLocal create(String id, float balance)
		throws CreateException;

	/**
	 * Finds an instance using a key for Entity Bean: Account
	 */
	public AccountLocal findByPrimaryKey(String primaryKey)
		throws javax.ejb.FinderException;

	/**
	 * Finds a collection of Accounts, based on a balance threshold
	 */
	public Collection findByBalanceThreshold(float threshold)
		throws FinderException;

	/**
	 * Computes the total of all balances of all Accounts
	 */
	public float computeTotalBalances() throws FinderException;

	/**
	 * Resets the back-end datastore to its original (empty) state
	 */
	public void reset();
}
