package com.ibm.websphere.samples.cmpa.sdorep;

//==============================================================================
//
// "This program may be used, executed, copied, modified and distributed without
// royalty for the purpose of developing, using, marketing, or distributing."
//
// Product 5724-H74,   5724-L01, 5655-N53, 5724-I82, 5655-R15 (C) COPYRIGHT International Business Machines Corp., 2004, 2006
// All Rights Reserved * Licensed Materials - Property of IBM
// US Government Users Restricted Rights - Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.
//
// @(#) 1.4 WBISRVR/ws/code/samp.cmpa/src/com/ibm/websphere/samples/cmpa/sdorep/SdoRepositoryInteractionSpec.java, WAS.samp.cmpa, WBI70.WBISRVR, of1033.11 4/13/06 22:10:31 [8/24/10 06:41:34]
//
//==============================================================================

import javax.resource.cci.InteractionSpec;


/**
 * <p>Interaction Specification for cmpaSdoRepository.rar</p>
 *
 * @author jalcorn@us.ibm.com
 */
public class SdoRepositoryInteractionSpec implements InteractionSpec {
   //Basic "CRUD" interactions
   public static String CREATE   = "ejbCreate";
   public static String RETRIEVE = "ejbFindByPrimaryKey";
   public static String UPDATE   = "ejbStore";
   public static String DELETE   = "ejbRemove";

   //Other generically useful interactions
   public static String ALL_KEYS = "ejbFindAll";
   public static String RESET    = "ejbHomeReset";

   private String ivFunctionName  = null;


   /**
    * Default constructor
    */
   public SdoRepositoryInteractionSpec() {
   }


   /**
    * Getter for function name.
    *
    * @return String The current value of the function name
    */
   public String getFunctionName() {
      return ivFunctionName;
   }


   /**
    * Setter for function name.
    *
    * @param functionName The new value of the function name
    */
   public void setFunctionName(String functionName) {
      ivFunctionName = functionName;
   }
}
