package com.ibm.websphere.samples.cmpa.sdorep.rar;

//==============================================================================
//
// "This program may be used, executed, copied, modified and distributed without
// royalty for the purpose of developing, using, marketing, or distributing."
//
// Product 5724-H74,   5724-L01, 5655-N53, 5724-I82, 5655-R15 (C) COPYRIGHT International Business Machines Corp., 2004, 2006
// All Rights Reserved * Licensed Materials - Property of IBM
// US Government Users Restricted Rights - Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.
//
// @(#) 1.3 WBISRVR/ws/code/samp.cmpa/src/com/ibm/websphere/samples/cmpa/sdorep/rar/SdoRepositoryConnectionFactoryImpl.java, WAS.samp.cmpa, WBI70.WBISRVR, of1033.11 4/13/06 22:10:32 [8/24/10 06:41:34]
//
//==============================================================================

import javax.naming.NamingException;
import javax.naming.Reference;
import javax.resource.cci.Connection;
import javax.resource.cci.ConnectionFactory;
import javax.resource.cci.ConnectionSpec;
import javax.resource.cci.RecordFactory;
import javax.resource.cci.ResourceAdapterMetaData;
import javax.resource.NotSupportedException;
import javax.resource.ResourceException;


/**
 * Connection factory for cmpaSdoRepository.rar
 *
 * @author John W. Alcorn (jalcorn@us.ibm.com)
 */
public class SdoRepositoryConnectionFactoryImpl implements ConnectionFactory {
   //the "fake" connection is a singleton
   private static Connection connection = null;

   private Reference reference = null;

   public Connection getConnection() throws ResourceException {
      if (connection == null) {
         connection = new SdoRepositoryConnectionImpl();
      }
      return connection;
   }

   public Connection getConnection(ConnectionSpec spec) throws ResourceException {
      return getConnection();
   }

   public RecordFactory getRecordFactory() throws ResourceException {
      throw new NotSupportedException("getRecordFactory()");
   }

   public ResourceAdapterMetaData getMetaData() throws ResourceException {
      throw new NotSupportedException("getMetaData()");
   }

   public Reference getReference() throws NamingException {
      return reference;
   }

   public void setReference(Reference newReference) {
      reference = newReference;
   }
}
