package com.ibm.websphere.samples.cmpa.sdorep.rar;

//==============================================================================
//
// "This program may be used, executed, copied, modified and distributed without
// royalty for the purpose of developing, using, marketing, or distributing."
//
// Product 5724-H74,   5724-L01, 5655-N53, 5724-I82, 5655-R15 (C) COPYRIGHT International Business Machines Corp., 2004, 2006
// All Rights Reserved * Licensed Materials - Property of IBM
// US Government Users Restricted Rights - Use, duplication or disclosure
// restricted by GSA ADP Schedule Contract with IBM Corp.
//
// @(#) 1.3 WBISRVR/ws/code/samp.cmpa/src/com/ibm/websphere/samples/cmpa/sdorep/rar/SdoRepositoryManagedConnectionFactoryImpl.java, WAS.samp.cmpa, WBI70.WBISRVR, of1033.11 4/13/06 22:10:38 [8/24/10 06:41:34]
//
//==============================================================================

import java.io.PrintWriter;
import java.util.Set;
import javax.resource.cci.ConnectionFactory;
import javax.resource.spi.ConnectionManager;
import javax.resource.spi.ConnectionRequestInfo;
import javax.resource.spi.ManagedConnection;
import javax.resource.spi.ManagedConnectionFactory;
import javax.resource.NotSupportedException;
import javax.resource.ResourceException;
import javax.security.auth.Subject;


/**
 * Managed connection factory for cmpaSdoRepository.rar
 *
 * @author John W. Alcorn (jalcorn@us.ibm.com)
 */
public class SdoRepositoryManagedConnectionFactoryImpl implements ManagedConnectionFactory {
   //the connectionFactory is a singleton
   private static ConnectionFactory connectionFactory = null;

   private PrintWriter logWriter = null;

   public Object createConnectionFactory() throws ResourceException {
      if (connectionFactory == null) {
         connectionFactory = new SdoRepositoryConnectionFactoryImpl();
      }
      return connectionFactory;
   }

   public Object createConnectionFactory(ConnectionManager manager) throws ResourceException {
      return createConnectionFactory();
   }

   public ManagedConnection createManagedConnection(Subject subject, ConnectionRequestInfo info) throws ResourceException {
      throw new NotSupportedException("createManagedConnection(Subject, ConnectionRequestInfo)");
   }

   public ManagedConnection matchManagedConnections(Set set, Subject subject, ConnectionRequestInfo info) throws ResourceException {
      throw new NotSupportedException("matchManagedConnections(Set, Subject, ConnectionRequestInfo)");
   }

   public PrintWriter getLogWriter() throws ResourceException {
      return logWriter;
   }

   public void setLogWriter(PrintWriter printWriter) throws ResourceException {
      logWriter = printWriter;
   }

   public boolean equals(Object obj) {
      boolean isEqual = false;

      if (obj instanceof SdoRepositoryManagedConnectionFactoryImpl) {
         isEqual = true; //all SdoRepositoryManagedConnectionFactoryImpl's are identical
      }

      return isEqual;
   }

   public int hashCode() {
      return 0;
   }
}
